=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2010-08-15 15:20:14 +0000
+++ bzrlib/graph.py	2010-12-11 22:06:52 +0000
@@ -1770,6 +1770,9 @@
     def merge_sort(self, tip_revision):
         return self._graph.merge_sort((tip_revision,))
 
+    def add_node(self, revision, parents):
+        self._graph.add_node((revision,), [(p,) for p in parents])
+
 
 _counters = [0,0,0,0,0,0,0]
 try:

=== modified file 'bzrlib/tests/test_graph.py'
--- bzrlib/tests/test_graph.py	2010-08-15 15:20:14 +0000
+++ bzrlib/tests/test_graph.py	2010-12-11 22:06:52 +0000
@@ -1654,6 +1654,14 @@
         self.assertEqual(['D'], sorted(graph_thunk.heads(['D', 'C'])))
         self.assertEqual(['B', 'C'], sorted(graph_thunk.heads(['B', 'C'])))
 
+    def test_add_node(self):
+        d = {('C',):[('A',)], ('B',): [('A',)], ('A',): []}
+        g = _mod_graph.KnownGraph(d)
+        graph_thunk = _mod_graph.GraphThunkIdsToKeys(g)
+        graph_thunk.add_node("D", ["A", "C"])
+        self.assertEqual(['B', 'D'],
+            sorted(graph_thunk.heads(['D', 'B', 'A'])))
+
 
 class TestPendingAncestryResultGetKeys(TestCaseWithMemoryTransport):
     """Tests for bzrlib.graph.PendingAncestryResult."""

